open Img_ex

#load "bigarray.cma";;
#load "grayimg.cmo";;
#load "img_interp.cmo";;
#load "img_ex.cmo";;
#load "img_comp.cmo";;

let module M = Ex1(Img_interp) in
  Img_interp.run M.res
;;

(* - : Img_interp.value = Img_interp.Int 7 *)
(* ZZZ notice the tag! *)

let module M = Ex2(Img_interp) in
  Img_interp.run M.res
;;
(* - : Img_interp.value = Img_interp.Int 5 *)

let module M = Ex3(Img_interp) in
  Img_interp.run M.res
;;

let module M = Ex4(Img_interp) in
  Img_interp.run M.res
;;

let module M = Ex5(Img_interp) in
  Img_interp.run M.res
;;

(* A differerent way to run it: *)
let open Img_interp in
 run 
  (display (iterate (load "takaosan.pgm")
             (if_ (it >% int 128) (int 2 *% (it -% int 128)) (int 0))));;


(* Compilation *)
let module M = Ex1(Img_comp) in
  Img_comp.run M.res
;;

(* - : int code = .<1 + (2 * 3)>.  *)

let module M = Ex1(Img_comp) in
  Runcode.run @@ Img_comp.run M.res
;;

(* - : int = 7 *)
(* Before, with the interpreter: - : Imgdsl.value = Int 7 *)
(* ZZZ Now, no tags! val - : int = 7 *)

let module M = Ex2(Img_comp) in
  Img_comp.run M.res
;;

(* - : int code = .<if 1 > 3 then 4 else 5>.  *)

let module M = Ex3(Img_comp) in
  Img_comp.run M.res
;;

(*
- : int code = .<
let lv_1 = Grayimg.read_pgm "takaosan.pgm"  in
let lv_2 = Grayimg.display ?cmd:(Some "xv") lv_1; 0  in lv_2>. 
*)

let module M = Ex3(Img_comp) in
  Runcode.run @@ Img_comp.run M.res
;;

let module M = Ex4(Img_comp) in
  Img_comp.run M.res
;;

(*
- : int code = .<
let lv_5 = Grayimg.read_pgm "takaosan.pgm"  in
let lv_9 =
  let pxs_6 = Grayimg.pixels lv_5  in
  for i_7 = 0 to (Bigarray.Array1.dim pxs_6) - 1 do
    (let p_8 = Bigarray.Array1.unsafe_get pxs_6 i_7  in
     Bigarray.Array1.unsafe_set pxs_6 i_7 (if p_8 > 120 then p_8 else 0))
  done;
  lv_5  in
let lv_10 = Grayimg.display ?cmd:(Some "xv") lv_9; 0  in lv_10>. 
*)

let module M = Ex4(Img_comp) in
  Runcode.run @@ Img_comp.run M.res
;;

let module M = Ex5(Img_comp) in
  Img_comp.run M.res
;;

(*
- : int code = .<
let lv_17 = Grayimg.read_pgm "takaosan.pgm"  in
let lv_21 =
  let pxs_18 = Grayimg.pixels lv_17  in
  for i_19 = 0 to (Bigarray.Array1.dim pxs_18) - 1 do
    (let p_20 = Bigarray.Array1.unsafe_get pxs_18 i_19  in
     Bigarray.Array1.unsafe_set pxs_18 i_19
       (if p_20 > 128 then 2 * (p_20 - 128) else 0))
  done;
  lv_17  in
let lv_22 = Grayimg.display ?cmd:(Some "xv") lv_21; 0  in lv_22>. 
*)
(* No longer any tagging and untagging! *)

(* A differerent way to compile it: *)
let ex5c =
 let open Img_comp in
 run 
  (display (iterate (load "takaosan.pgm")
             (if_ (it >% int 128) (int 2 *% (it -% int 128)) (int 0))));;

let ex5v = Runcode.run ex5c;;

let _ = Img_comp.run_natively ex5c;;

